package studentmanagement.service.administrator;

import studentmanagement.model.dto.create.AdminRegisterRequest;
import studentmanagement.model.dto.create.AdminUpsertRequest;
import studentmanagement.model.dto.find.AdminIdNameDto;
import studentmanagement.model.dto.find.StudentCourseIdRequest;
import studentmanagement.model.dto.find.TeacherCourseIdRequest;
import studentmanagement.model.dto.response.AdminUpsertResponse;
import studentmanagement.model.dto.response.LoginResponse;
import studentmanagement.model.dto.response.StudentCourseResponse;
import studentmanagement.model.dto.response.TeacherCourseResponse;
import studentmanagement.model.key.IDableKey;
import studentmanagement.model.person.Person;
import studentmanagement.model.person.admin.Admin;
import studentmanagement.service.generic.Service;

import java.util.List;

public interface AdministratorService extends Service<Admin> {
    LoginResponse registerAdmin(AdminRegisterRequest request);

    Admin create(AdminRegisterRequest request);

    Admin create(Person person);

    AdminIdNameDto findByIdMappedToDto(IDableKey adminKey);

    List<AdminIdNameDto> findAllMappedToDto();

    Admin findByUsername(String username);

    Admin findByUsernameOrElse(String username, Admin orElse);

    TeacherCourseResponse employ(TeacherCourseIdRequest dto);

    TeacherCourseResponse fire(TeacherCourseIdRequest dto);

    StudentCourseResponse enroll(StudentCourseIdRequest dto);

    StudentCourseResponse dismiss(StudentCourseIdRequest dto);

    AdminUpsertResponse upsert(AdminUpsertRequest request);
}