package studentmanagement.service.cookie;

import jakarta.servlet.http.Cookie;
import jakarta.servlet.http.HttpServletRequest;
import org.springframework.http.ResponseCookie;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.Optional;

@Service
public class CookieUtil {
    public static final String COOKIE_NAME = "cookie";

    public Optional<Cookie> findServletCookie(HttpServletRequest request, String name) {
        Cookie[] cookies = request.getCookies();

        if (cookies == null) {
            return Optional.empty();
        }

        return Arrays.stream(request.getCookies())
            .filter(cookie -> name.equals(cookie.getName()))
            .findAny();
    }

    public ResponseCookie createCookie(String token, String cookieName) {
        return ResponseCookie.from(cookieName, token)
            .httpOnly(true)
            .secure(true)
            .path("/")
            .maxAge(3600)
            .domain("localhost")
            .build();
    }

    public ResponseCookie deleteCookie() {
        return ResponseCookie.from("user-id", "")
            .maxAge(0)
            .build();
    }
}