package studentmanagement.service.course;

import studentmanagement.model.course.Course;
import studentmanagement.model.course.dto.CourseStudentListDto;
import studentmanagement.model.dto.create.CourseCreateRequest;
import studentmanagement.model.dto.create.CourseUpsertRequest;
import studentmanagement.model.dto.response.CourseCreateResponse;
import studentmanagement.model.key.IDableKey;
import studentmanagement.service.generic.Service;

import java.util.List;

public interface CourseService extends Service<Course> {
    CourseCreateResponse create(CourseCreateRequest dto);

    CourseCreateResponse upsert(CourseUpsertRequest dto);

    CourseStudentListDto findByIdMappedToDto(IDableKey courseKey);

    List<CourseStudentListDto> findAllMappedToDto();

    List<CourseStudentListDto> findAllSortedByNameMappedToDto();
}
