package studentmanagement.service.grade;

import studentmanagement.model.course.dto.CourseStudentListDto;
import studentmanagement.model.dto.create.AddGradeRequest;
import studentmanagement.model.dto.find.GradeDto;
import studentmanagement.model.grade.Grade;
import studentmanagement.model.dto.GradeEntry;
import studentmanagement.model.key.IDableKey;

import java.util.Collection;
import java.util.List;

public interface GradeService {
    Grade save(Grade grade);

    Collection<Grade> saveAll(Collection<Grade> grades);

    List<GradeDto> findByStudentId(IDableKey studentKey);

    List<GradeDto> findByCourseId(IDableKey courseKey);

    List<GradeDto> findByStudentIdAndCourseId(IDableKey studentKey, IDableKey courseKey);

    List<GradeDto> findAllMappedToDto();

    List<GradeDto> deleteByStudentId(IDableKey studentKey);

    List<GradeDto> deleteByCourseId(IDableKey courseKey);

    List<GradeDto> deleteByStudentIdAndCourseId(IDableKey studentKey, IDableKey courseKey);

    GradeDto addGrade(AddGradeRequest dto);

    Double findAverageForStudent(IDableKey studentKey);

    Double findAverageForCourse(IDableKey courseKey);

    Double findAverageForStudentInCourse(IDableKey studentKey, IDableKey courseKey);

    List<GradeEntry> getAverageGradesByStudent();

    List<GradeEntry> getAverageGradesByStudentForCourse(IDableKey iDableKey);

    List<CourseStudentListDto> getStudentsByCourseSortedByGrade();
}
