package studentmanagement.service.jwt.purger;

import jakarta.annotation.PostConstruct;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import studentmanagement.service.jwt.JwtService;

import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

@Service
@RequiredArgsConstructor
public class TokensPurgerService implements Runnable {

    @Autowired
    private final JwtService jwtService;

    @Override
    public void run() {
        ScheduledExecutorService threads = new ScheduledThreadPoolExecutor(
            1);

        Thread purgeTask = new Thread(new JwtTokenPurger(jwtService));
        purgeTask.setDaemon(true);
        purgeTask.setName("Purge Task");

        threads.scheduleAtFixedRate(purgeTask, 0, 10, TimeUnit.SECONDS);
    }

    @PostConstruct
    public void start() {
        Thread thread = new Thread(this);
        thread.setName("PurgerService Thread");
        thread.start();
    }
}