package studentmanagement.service.student;

import studentmanagement.model.dto.create.StudentRegisterRequest;
import studentmanagement.model.dto.create.StudentUpsertRequest;
import studentmanagement.model.dto.find.StudentIdNameDto;
import studentmanagement.model.dto.response.StudentUpsertResponse;
import studentmanagement.model.key.IDableKey;
import studentmanagement.model.person.Person;
import studentmanagement.model.person.student.Student;
import studentmanagement.service.generic.Service;

import java.util.List;

public interface StudentService extends Service<Student> {
    Student create(StudentRegisterRequest dto);

    Student create(Person person);

    Student findByUsername(String username);

    Student findByUsernameOrElse(String username, Student orElse);

    StudentUpsertResponse upsert(StudentUpsertRequest dto);

    StudentIdNameDto findByIdMappedToDto(IDableKey studentKey);

    List<StudentIdNameDto> findAllMappedToDto();
}
