package studentmanagement.service.teacher;

import studentmanagement.model.dto.create.TeacherRegisterRequest;
import studentmanagement.model.dto.create.TeacherUpsertRequest;
import studentmanagement.model.dto.find.TeacherIdNameDto;
import studentmanagement.model.dto.response.TeacherUpsertResponse;
import studentmanagement.model.key.IDableKey;
import studentmanagement.model.person.Person;
import studentmanagement.model.person.teacher.Teacher;
import studentmanagement.service.generic.Service;

import java.util.List;

public interface TeacherService extends Service<Teacher> {
    Teacher create(TeacherRegisterRequest dto);

    Teacher create(Person person);

    Teacher findByUsername(String username);

    Teacher findByUsernameOrElse(String username, Teacher orElse);

    TeacherUpsertResponse upsert(TeacherUpsertRequest dto);

    TeacherIdNameDto findByIdMappedToDto(IDableKey teacherKey);

    List<TeacherIdNameDto> findAllMappedToDto();
}
