package studentmanagement.service.student;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.mockito.Mockito;
import studentmanagement.data.student.StudentRepository;
import studentmanagement.model.dto.create.StudentRegisterRequest;
import studentmanagement.model.person.student.Student;

class DefaultStudentServiceTest {
    private final long id = 1L;
    private final String name = "Filip";
    private final long age = 21;
    private final Student student = new Student(name, age);
    private final String ageString = "21";

    private StudentRepository mockStudentRepo;
    private StudentService studentService;

    @BeforeEach
    void setUpTestCase() {
        student.setId(id);
        mockStudentRepo = Mockito.mock(StudentRepository.class);
        studentService = new DefaultStudentService(mockStudentRepo);
    }

    @Test
    void add_Adds_Student_Correctly() {
        Mockito.when(mockStudentRepo.saveAndFlush(Mockito.any())).thenReturn(student);

        Student actual = studentService.create(new StudentRegisterRequest(name, age));

        Assertions.assertEquals(student, actual, "Student was not added correctly");
    }

    @Test
    void overloaded_Add_Adds_Student_Correctly() {
        Mockito.when(mockStudentRepo.saveAndFlush(Mockito.any())).thenReturn(student);

        Student actual = studentService.create(new StudentRegisterRequest(name, age));

        Assertions.assertEquals(student, actual, "Student was not added correctly");
    }
}