package studentmanagement.service.teacher;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.mockito.Mockito;
import studentmanagement.data.teacher.TeacherRepository;
import studentmanagement.model.dto.create.TeacherRegisterRequest;
import studentmanagement.model.person.teacher.Degree;
import studentmanagement.model.person.teacher.Teacher;

class DefaultTeacherServiceTest {
    private TeacherRepository mockTeacherRepo;
    private TeacherService teacherService;

    @BeforeEach
    void setUpTestCase() {
        mockTeacherRepo = Mockito.mock(TeacherRepository.class);
        teacherService = new DefaultTeacherService(mockTeacherRepo, teacherMapper, bCryptPasswordEncoder);
    }

    @Test
    void add_Adds_Teacher_Correctly() {
        long id = 1L;
        String name = "Filip";
        Degree degree = Degree.PHD;

        Teacher teacher = new Teacher(name, degree);
        teacher.setId(id);

        Mockito.when(mockTeacherRepo.saveAndFlush(Mockito.any())).thenReturn(teacher);

        Teacher actual = teacherService.create(new TeacherRegisterRequest(name, degree.getAsString()));

        Assertions.assertEquals(teacher, actual);
    }
}