package studentmanagement.mapper.course;

import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import studentmanagement.model.course.Course;
import studentmanagement.model.course.dto.CourseStudentListDto;
import studentmanagement.model.dto.create.CourseCreateRequest;
import studentmanagement.model.dto.create.CourseUpsertRequest;
import studentmanagement.model.dto.response.CourseCreateResponse;
import studentmanagement.model.dto.find.CourseIdNameDto;

@Mapper(componentModel = "spring")
public interface CourseMapper {
    @Mapping(target = "students", ignore = true)
    @Mapping(target = "teacher", ignore = true)
    @Mapping(target = "id", ignore = true)
    Course courseCreateRequestToCourse(CourseCreateRequest request);

    @Mapping(target = "students", ignore = true)
    @Mapping(target = "teacher", ignore = true)
    Course courseUpsertRequestToCourse(CourseUpsertRequest request);

    CourseIdNameDto courseToCourseIdNameDto(Course course);

    @Mapping(source = ".", target = "course")
    CourseStudentListDto courseToCourseStudentListDto(Course course);

    CourseCreateResponse courseToCourseCreateResponse(Course course);
}
