package studentmanagement.model.course.dto;

import studentmanagement.model.dto.find.CourseIdNameDto;
import studentmanagement.model.dto.find.StudentIdNameDto;
import studentmanagement.model.dto.find.TeacherIdNameDto;

import java.util.List;

public record CourseStudentListDto(CourseIdNameDto course, List<StudentIdNameDto> students,
                                   TeacherIdNameDto teacher)
    implements Comparable<CourseStudentListDto> {

    @Override
    public boolean equals(Object o) {
        if (this == o)
            return true;
        if (o == null || getClass() != o.getClass())
            return false;

        CourseStudentListDto dto = (CourseStudentListDto) o;

        return course.equals(dto.course);
    }

    @Override
    public int hashCode() {
        return course.hashCode();
    }

    @Override
    public int compareTo(CourseStudentListDto o) {
        return course.getName().compareTo(o.course.getName());
    }
}
