package studentmanagement.model.dto.create;

import jakarta.validation.constraints.Max;
import jakarta.validation.constraints.Min;
import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.Positive;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import studentmanagement.model.key.IDableKey;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class AddGradeRequest {
    @NotNull
    private IDableKey studentKey;

    @NotNull
    private IDableKey courseKey;

    @NotNull
    @Min(value = 2)
    @Max(value = 6)
    private Double grade;
}
