package studentmanagement.model.dto.create;

import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.Positive;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import studentmanagement.model.role.Role;

@AllArgsConstructor
@NoArgsConstructor
@Data
public class AdminUpsertRequest {
    @Positive
    @NotNull
    private Long id;

    @NotNull
    @NotBlank
    private String name;

    @NotNull
    @NotBlank
    private String username;

    @NotNull
    @NotBlank
    private String password;

    private Role authority = Role.ADMIN;
}