package studentmanagement.model.dto.create;

import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.Positive;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import studentmanagement.model.key.IDableKey;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class CourseCreateRequest {

    @NotNull
    @NotBlank
    private String name;

    @NotNull
    @Positive
    private Long totalHours;

    @Positive
    private Long teacherId;

    public IDableKey teacherKey() {
        return new IDableKey(teacherId == null ? 0 : teacherId);
    }
}