package studentmanagement.model.dto.create;


import jakarta.validation.constraints.Min;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.Positive;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import studentmanagement.model.role.Role;

@AllArgsConstructor
@NoArgsConstructor
@Data
public class StudentUpsertRequest {
    @NotNull
    @Positive
    private Long id;

    @NotNull
    @NotBlank
    private String name;

    @NotNull
    @NotBlank
    private String username;

    @NotNull
    @NotBlank
    private String password;

    @NotNull
    @Positive
    @Min(value = 18)
    private Long age;

    private Role authority = Role.STUDENT;
}
