package studentmanagement.model.dto.find;

import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.Positive;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import studentmanagement.model.key.IDableKey;

@Data
@AllArgsConstructor
@NoArgsConstructor
public class StudentCourseIdRequest {

    @NotNull
    @Positive
    private Long studentId;

    @NotNull
    @Positive
    private Long courseId;

    public IDableKey studentKey() {
        return new IDableKey(studentId);
    }

    public IDableKey courseKey() {
        return new IDableKey(courseId);
    }
}
