package studentmanagement.model.dto.find;

import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.Positive;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import studentmanagement.model.key.IDableKey;

@Data
@AllArgsConstructor
@NoArgsConstructor
public class TeacherCourseIdRequest {

    @NotNull
    @Positive
    private Long teacherId;

    @NotNull
    @Positive
    private Long courseId;

    public IDableKey teacherKey() {
        return new IDableKey(teacherId);
    }

    public IDableKey courseKey() {
        return new IDableKey(courseId);
    }
}
