package studentmanagement.model.grade;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;
import jakarta.validation.constraints.Max;
import jakarta.validation.constraints.Min;
import jakarta.validation.constraints.NotNull;
import lombok.Getter;
import lombok.Setter;
import studentmanagement.model.DefaultIDable;
import studentmanagement.model.course.Course;
import studentmanagement.model.person.student.Student;

@Getter
@Setter
@Entity
@Table(name = "Grade")
public class Grade extends DefaultIDable implements Comparable<Grade> {
    @Column
    @NotNull
    @Min(value = 2)
    @Max(value = 6)
    private Double grade;

    @ManyToOne
    @NotNull
    private Student student;
    @ManyToOne
    @NotNull
    private Course course;

    @Override
    public int compareTo(Grade o) {
        return Double.compare(grade, o.getGrade());
    }
}
