package studentmanagement.model.person.student;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.ManyToMany;
import jakarta.persistence.Table;
import jakarta.validation.constraints.Min;
import jakarta.validation.constraints.Positive;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import studentmanagement.model.course.Course;
import studentmanagement.model.person.Person;

import java.util.HashSet;
import java.util.Set;

@Entity
@Table(name = "Students")
@Setter
@Getter
@AllArgsConstructor
@NoArgsConstructor
public class Student extends Person {

    @ManyToMany(mappedBy = "students")
    private transient Set<Course> courses = new HashSet<>();

    @Column
    @Positive
    @Min(value = 18)
    private Long age;
}
