package studentmanagement.model.token;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.OneToOne;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import studentmanagement.model.person.Person;

@AllArgsConstructor
@Data
@Entity
@NoArgsConstructor
public class Token {

    @NotNull
    @NotBlank
    @Column
    private String token;
    @OneToOne
    private Person person;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    public Token(String token, Person person) {
        this.token = token;
        this.person = person;
    }
}
